﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using FarPoint.Win.Spread;
using System.Collections;

namespace CustomFilterNotEqualToValue
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            fpSpread1_Sheet1.Cells[0, 1].Value = 30;
            fpSpread1_Sheet1.Cells[1, 1].Value = 150;
            fpSpread1_Sheet1.Cells[2, 1].Value = 100;
            fpSpread1_Sheet1.Cells[3, 1].Value = 320;
            fpSpread1_Sheet1.Cells[4, 1].Value = 154;
            fpSpread1_Sheet1.Cells[5, 1].Value = 100;
            fpSpread1_Sheet1.Cells[6, 1].Value = 23;
            fpSpread1_Sheet1.Cells[7, 1].Value = 170;
            fpSpread1_Sheet1.Cells[8, 1].Value = 100;
            fpSpread1_Sheet1.Rows.Count = 9;

            HideRowFilter hf = new HideRowFilter(fpSpread1_Sheet1);

            fpSpread1.ActiveSheet.Columns[1].AllowAutoFilter = true;
            int[] myColValueArray = new int[fpSpread1_Sheet1.Rows.Count + 1];
            for (int i = 0; i <= fpSpread1_Sheet1.Rows.Count - 1; i++)
            {
                myColValueArray[i] = (int)fpSpread1_Sheet1.Cells[i, 1].Value;
            }
            NotEqualTOValue cf = new NotEqualTOValue(fpSpread1_Sheet1, 100);
            FarPoint.Win.Spread.FilterColumnDefinition fcd = default(FarPoint.Win.Spread.FilterColumnDefinition);
            fcd = fpSpread1.ActiveSheet.RowFilter.GetFilterColumnDefinition(1);
            fcd.Filters.Add(cf);
        }
    }


    public class NotEqualTOValue : FarPoint.Win.Spread.BaseFilterItem
    {
        private int _p2;

        FarPoint.Win.Spread.SheetView sv = null;
        public NotEqualTOValue()
        {
        }

        public NotEqualTOValue(FarPoint.Win.Spread.SheetView sheetView, Int16 val)
        {
            this.sv = sheetView;
            this._p2 = val;
        }
        public override string DisplayName
        {
            get { return "Not Equal to 100"; }
        }
        public override FarPoint.Win.Spread.SheetView SheetView
        {
            set { sv = value; }
        }


        public bool IsFilteredIn(Int16 value)
        {
            if (Convert.ToInt16(value) != 0 & value != 100)
            {
                return true;
            }
            return false;
        }

        public override bool ShowInDropDown(int columnIndex, int[] filteredInRowList)
        {
            if (filteredInRowList == null)
            {
                return true;
            }
            int i = 0;
            for (i = 0; i <= filteredInRowList.Length - 1; i++)
            {
                int row = filteredInRowList[i];
                string value = sv.GetText(row, columnIndex);
                if ((value != null) & value.Length > 0)
                {
                    if (IsFilteredIn(Convert.ToInt16(value)))
                    {
                        return true;
                    }
                }
            }
            return false;
        }
        public override int[] Filter(int columnIndex)
        {
            ArrayList list = new ArrayList();
            int[] returnList = null;
            int row = 0;
            for (row = 0; row <= sv.RowCount - 1; row++)
            {
                string value = sv.GetText(row, columnIndex);
                if (IsFilteredIn(Convert.ToInt16(value)))
                {
                    list.Add(row);
                }
            }
            if (list.Count > 0)
            {
                returnList = new int[list.Count];
                list.CopyTo(returnList);
                list.Clear();
            }
            return returnList;
        }

        public override bool Serialize(System.Xml.XmlTextWriter w)
        {
            return true;
        }

        public override bool Deserialize(System.Xml.XmlNodeReader r)
        {
            return true;
        }
    }

}
